COMMENT @

SEH.inc (MASM)
-------
...a lame include file for SEH macro's.

by yoda

@

;---- STRUCTs ----
sSEH STRUCT
	OrgEsp            DD ?
	OrgEbp            DD ?
	SaveEip           DD ?
sSEH ENDS

;---- MACROs ----
InstSehFrame MACRO ContinueAddr
	ASSUME FS : NOTHING
	
   IFNDEF  SehStruct
        SehStruct EQU 1
     	.DATA
     	SEH    sSEH <>
   ENDIF
   
	.CODE
	MOV  SEH.SaveEip, ContinueAddr
	MOV  SEH.OrgEbp, EBP
	PUSH OFFSET SehHandler
	PUSH FS:[0]
	MOV  SEH.OrgEsp, ESP
	MOV  FS:[0], ESP
ENDM

KillSehFrame MACRO
	POP  FS:[0]
	ADD  ESP, 4
ENDM

;---- ROUTINEs ----
.CODE
SehHandler PROC C pExcept:DWORD,pFrame:DWORD,pContext:DWORD,pDispatch:DWORD
	MOV EAX,pExcept
	assume eax:ptr EXCEPTION_RECORD
	.if [EAX].ExceptionCode==STATUS_STACK_OVERFLOW
		MOV  EAX, pContext
		ASSUME EAX : PTR CONTEXT
		PUSH SEH.SaveEip
		POP  [EAX].regEip
		PUSH SEH.OrgEsp
		POP  [EAX].regEsp
		PUSH SEH.OrgEbp
		POP [EAX].regEbp

		MOV  EAX, ExceptionContinueExecution
	.else
		MOV EAX,ExceptionContinueSearch
	.endif
	RET
SehHandler ENDP